package
{
	import mx.core.*;
	import mx.collections.*;
	import mx.containers.*;
	import flash.display.*;
	import flash.geom.*;
	import flash.events.*;
	import flash.text.*;
	import flash.utils.*;	
	import flash.ui.Keyboard;

	public class Game
	{		
		public static var instance:Game;
		
		public var T_PHYS:int=25;
		private var IS_FINAL:Boolean = false;
		
		private static var GAMESTATE_GAME:int = 0;
		private static var GAMESTATE_FE:int = 1;
		
		public var ui:UIComponent;
		public var canvas:Canvas;

		private var fps:Number=60;
		private var lastTime:int = 0;
		private var fpsText:TextField;
				
		private var updateTracker:Number = 0;
		
		private var gameState:int = GAMESTATE_GAME;
		
		public function Game()
		{
		}	
			
		public function creationComplete():void
		{			
			BlitRenderer.getInstance().init();
			SoundManager.getInstance();

			gameState = GAMESTATE_GAME;
			
			fpsText = new TextField();
			fpsText.textColor = 0xffffffff;
			fpsText.text = "352 fps";
			
			EntityManager.getInstance().push(TileMap.getInstance());
			EntityManager.getInstance().push(Platformer.getInstance());
		}
		
		private function update():void
		{
			BlitRenderer.getInstance().update();
			EntityManager.getInstance().update();
			if(gameState == GAMESTATE_FE)
				Frontend.getInstance().update();			
			Input.getInstance().update(); // Do this last, so mouse presses etc. will register first.. also note this mode of operation isn't perfect, sometimes input will be lost!
		}
		
		private function render():void
		{
			BlitRenderer.getInstance().cls();
			EntityManager.getInstance().render();
			if(gameState == GAMESTATE_FE)
				Frontend.getInstance().render();
			BlitRenderer.getInstance().drawFontText("Jonathan Whiting's Basecode", BlitRenderer.SCR_WIDTH/2, 10, true);
				
			if(!IS_FINAL)
				BlitRenderer.getInstance().backBuffer.draw(fpsText);
			canvas.graphics.clear();
			BlitRenderer.getInstance().flip(canvas.graphics);
		}
		
		public function enterFrame(event:Event):void
		{
			var thisTime:int = getTimer();
			fps = (fps*9 + 1000/(thisTime-lastTime))/10;
			updateTracker += thisTime-lastTime;
			lastTime = thisTime;
			if(fpsText)
				fpsText.text = "FPS: "+int(fps);
			
			while(updateTracker > 0)
			{
				update();
				updateTracker -= T_PHYS;
			}
									
			if(BlitRenderer.getInstance())
			{					
				render();
			}	
		}
					
		public function keyUp(event:KeyboardEvent):void
		{
			Input.getInstance().keyUp(event);
		}		
		
		public function keyDown(event:KeyboardEvent):void
		{
			Input.getInstance().keyDown(event);
		}
		
		public function mouseMove(event:MouseEvent):void
		{
			Input.getInstance().mouseMove(event);
		}
		
		public function mouseDown(event:MouseEvent):void
		{
			Input.getInstance().mouseDown(event);
		}
		
		public function mouseUp(event:MouseEvent):void
		{
			Input.getInstance().mouseUp(event);
		}		
		
		public function getState():int
		{
			return gameState;
		}
		
		public function changeState(state:int):void
		{
			gameState = state;
		}
		
		public static function getInstance():Game
		{
			return Game.instance;
		}
	}
}