package
{
	import mx.core.*;
	import mx.collections.*;
	import flash.geom.*
	import flash.ui.Keyboard;
	import flash.utils.Dictionary;
	
	public class Platformer extends Entity
	{
		private static var _instance:Platformer;
		
		private static var SUB_MOVES:int = 4;
	
		public var jumpTimer:int;
		public var frame:int;
		
		private var restorePos:Point;
	
		public function Platformer()
		{
			sprite = BlitRenderer.SPRITE_TEST;
			reset();
		}
		
		public function reset():void
		{
			jumpTimer = 0;
			frame = 0;
			pos = new Point(0,0);
			speed = new Point(0,0);
		}
		
		public function ptop():Number {return pos.y-1}
		public function pbottom():Number {return pos.y+TileMap.tileWidth-4}
		public function pleft():Number {return pos.x-2}
		public function pright():Number {return pos.x+TileMap.tileWidth-5}
		
		public function updateRun():void
		{
			if(Input.getInstance().leftKey())
			{				
				speed.x -= 0.15;
				if(speed.x < -1)
					speed.x = -1;
				frame--;
				if(frame < 0)
					frame += 16;				
			}
			if(Input.getInstance().rightKey())
			{
				speed.x += 0.15;
				if(speed.x > 1)
					speed.x = 1;
				frame++;
				if(frame >= 16)
					frame -= 16;					
			}
			if(!Input.getInstance().leftKey() && !Input.getInstance().rightKey())
				speed.x /= 1.5;		
				
		}
		
		public function updateJump():void
		{
			var doJump:Boolean = false;
			
			// start  jump
			if(Input.getInstance().upKey(false) && jumpTimer == 11)
			{
				doJump = true;
			}
				
			// continue jump
			if(Input.getInstance().upKey() && jumpTimer > 0 && jumpTimer < 11)
				doJump = true;
				
			if(doJump)
			{
				speed.y -= 1/(12.0-jumpTimer)*0.725;
				jumpTimer--;
				frame = speed.x < 0 ? 12 : 7;
			}
			else
			{				
				jumpTimer = 0;
			}
			speed.y += 0.1;			
			
			if(speed.y > 3)
				speed.y = 3;
		}
		
		public function xMove(isFinal:Boolean):void
		{
			var colX:int = TileMap.COL_NONE;
			var colY:int = TileMap.COL_NONE;
			
			pos.x += speed.x/SUB_MOVES;
			if(speed.x)
			{
				var left:Boolean = speed.x < 0;		
				while(1)
				{
					var checkX:int = left ? pleft() : pright();
					
					colX = TileMap.getInstance().getColAtPos(new Point(checkX, ptop())) | TileMap.getInstance().getColAtPos(new Point(checkX, pbottom()));
					if(!(colX & TileMap.COL_WALL))
						break;
					pos.x += left ? 1 : -1;
					if(isFinal)
						speed.x = 0;
				}
			}
		}
		
		public function yMove(isFinal:Boolean):void
		{
			var colX:int = TileMap.COL_NONE;
			var colY:int = TileMap.COL_NONE;
			
			pos.y += speed.y/SUB_MOVES;
			var up:Boolean = speed.y < 0;
			if(speed.y)
			{		
				while(1)
				{
					var checkY:int = up ? ptop() : pbottom();

					colY = TileMap.getInstance().getColAtPos(new Point(pleft(), checkY)) | TileMap.getInstance().getColAtPos(new Point(pright(), checkY));
					if(!(colY & TileMap.COL_WALL))
						break;
					
					pos.y += up ? 0.01 : -0.01;
					if(isFinal)
					{
						jumpTimer = up ? 0 : 11;					
						speed.y = 0;					
					}
				}
			}
		}
		
		public override function update():void
		{
			updateRun();
			updateJump();
			for(var i:int=0; i<SUB_MOVES; i++)
			{
				xMove(i==SUB_MOVES-1);
				yMove(i==SUB_MOVES-1);
			}
			var mid:Point = new Point((pleft()+pright())/2, (ptop()+pbottom())/2);
		}
		
		public function setPos(inPos:Point):void
		{
			pos.x = inPos.x;
			pos.y = inPos.y;
			speed = new Point(0,0);
			jumpTimer = 0;
		}
		
		public static function getInstance():Platformer
		{
			if(! Platformer._instance)
				Platformer._instance = new Platformer();
			return Platformer._instance;			
		}			

	}
}