package
{
	import mx.core.*;
	import mx.collections.*;
	import flash.media.*;
	import flash.events.*;
	import SfxrSynth;

	public class SoundManager
	{
		private static var _instance:SoundManager;
		
		public static var SOUND_ENABLED:Boolean = true;
		public static var MUSIC_ENABLED:Boolean = false;
		
		public static var SOUND_TEST:int = 0;
		public static var NUM_SOUNDS:int = 1;
		
		//[Embed(source="sound/test.mp3")]
		//[Bindable]
		//public var mp3Music:Class;
		public var musicSound:SoundAsset;	
		public var channel:SoundChannel;
		
		public var sounds:Array;
		
		public function SoundManager()
		{
			sounds = new Array()
			
			var synth:SfxrSynth;
			for(var i:int = 0; i<NUM_SOUNDS; i++)
			{
				synth = new SfxrSynth();
				switch(i)
				{
					case SOUND_TEST: synth.setSettingsString("1,,0.073,,0.339,0.253,,0.38,-0.043,,,0.001,,,,0.561,-0.048,-0.039,1,-0.032,0.045,,-0.005,0.5"); break;
				}
				synth.cacheMutations(5);
				sounds.push(synth);
			}
			
			// Do music
			//musicSound = new mp3Music() as SoundAsset;			
			playMusic();
		}
		
		public function playSound(sound:int):void
		{
			if(!SOUND_ENABLED)
				return;
							
			sounds[sound].playCachedMutation();
		}
		
		public function playMusic():void
		{
			if(!MUSIC_ENABLED)
				return;
				
			stopMusic();
			if(musicSound)
			{
				channel = musicSound.play();
				setVol(0.1);
				channel.addEventListener(Event.SOUND_COMPLETE, soundCompleteHandler);
			}
		}
		
		public function stopMusic():void
		{
			if(channel)
				channel.stop();		
		}
		
		public function setVol(vol:Number):void
		{
			if(channel)
			{
            	var transform:SoundTransform = channel.soundTransform;
            	transform.volume = vol;
            	channel.soundTransform = transform;
			}
		}
		
        private function soundCompleteHandler(event:Event):void {
        	playMusic();
        }	        
				
		public static function getInstance():SoundManager
		{
			if(! SoundManager._instance)
				SoundManager._instance = new SoundManager();
			return SoundManager._instance;
		}        		
	}
}